#include "i3module.h"


main(){

  int i;

  char *options="-length=800 -radius=400 -romb=5 -raw -user -sdec -time -cont -lpm -bs=1 -ph=3 -bb=2 -sh=1 -scat -seed=1";

  char *name="mu-";
  double x=0;    // [m]
  double y=0;    // [m]
  double z=1000;    // [m]
  double theta=0;
  double phi=0;
  double e=2000; // [GeV] 
  double t=0;    // [s]

  double r, z1=0, z2=0, h1=0, h2=0, nx=0, ny=0, nz=0, e1=0, e2=0, ec=0;

  initJre();
  initMMC(options);
  propagate(name, x, y, z, theta, phi, e, t);

  // get the results

  for(i=0; i<getNum(); i++){
    startRead(i);

    name=getName();
    x=getDouble("x", 0);
    y=getDouble("y", 0);
    z=getDouble("z", 0);
    theta=getDouble("theta", 0);
    phi=getDouble("phi", 0);
    t=getDouble("t", 0);
    e=getDouble("e", 0);

    x*=1.e-2; y*=1.e-2; z*=1.e-2; theta=180-theta; phi=phi<180?phi+180:phi-180; e*=1.e-3;
    printf("%s %g %g %g %g %g %g %g\n", name, x, y, z, theta, phi, t, e);

    endRead();
  }

  r=getDouble("r", 1);
  e=getDouble("e", 1);
  z1=getDouble("z1", 2);
  z2=getDouble("z2", 2);
  h1=getDouble("h1", 2);
  h2=getDouble("h2", 2);
  nx=getDouble("nx", 2);
  ny=getDouble("ny", 2);
  nz=getDouble("nz", 2);
  e1=getDouble("e1", 2);
  e2=getDouble("e2", 2);
  ec=getDouble("ec", 2);

  r*=1.e-2; e*=1.e-3;
  printf("%g %g %g %g %g %g %g %g %g %g %g %g\n", r, e, z1, z2, h1, h2, nx, ny, nz, e1, e2, ec);

  stopJre();

}
